<?php
/**
 * fsl2006 congress
 * topic: PHP router in Asterisk
 * author: Moises Silva <moy@ivsol.net>
 * @package fsl-astcallmanager
 */

/**
 * sample pseudo daemon script to listen
 * for Newchannel events from Asterisk
 */

/* this function reads data from the provided socket
 * and return complete packets
 * @param resource $Socket
 * @return array
 * */
function read_packets($Socket)
{
	static $buffer  = '';
	$packets        = array();
	print "reading \n";
	$buffer .= fread($Socket, 1024);	
	/* at least 1 complete packet ? */
	if ( FALSE !== strpos($buffer, "\r\n\r\n") )
	{
		/* separe each packet */
		$packets = explode("\r\n\r\n", $buffer);
		/* the last packet ALWAYS is empty or not complete, save it in buffer */
		$buffer  = array_pop($packets);
	}
	return $packets;
}

/* connect and login */
$socket = fsockopen('localhost', 5038);
fread($socket, 1024); /* discard welcome message */
fwrite($socket, "Action: Login\r\n");
fwrite($socket, "Username: fsl\r\n");
fwrite($socket, "Secret: junio2006\r\n");
fwrite($socket, "\r\n");

/* infinite loop waiting for Newchannel events */
while ( TRUE  )
{
	$packets = read_packets($socket);
	foreach ( $packets as $packet )
	{
		/* is this a Newchannel packet? */
		if ( FALSE !== stripos($packet, 'Newchannel') )
		{
			$headers = explode("\r\n", $packet);
			foreach ( $headers as $header )
			{
				if ( FALSE !== stripos($header, "Channel") )
				{
					list(,$channel) = explode(':', $header);
					$channel        = trim($channel);
				}
			}
			print "New Channel: {$channel}\n";
		}
	}	
}
?>
