<?php
/**
 * fsl2006 congress
 * topic: PHP router in Asterisk
 * author: Moises Silva <moy@ivsol.net>
 * @package fsl-astcallmanager
 */

/**
 * originate a call to hello-world context
 */
$errno          = -1;
$errstr         = '';
/* open the manager socket */
$manager_socket = fsockopen('localhost', 5038, $errno, $errstr);
if ( is_resource($manager_socket) )
{
	/* read the Asterisk welcome message */
	$welcome        = fread($manager_socket, 1024);
	print $welcome . "\n";

	/* Write Login Action data in several steps for clarity */
	fwrite($manager_socket, "Action: Login\r\n");
	fwrite($manager_socket, "Username: fsl\r\n");
	fwrite($manager_socket, "Secret: junio2006\r\n");
	fwrite($manager_socket, "\r\n");

	/* read login response */
	$response       = fread($manager_socket, 1024);
	print $response . "\n";

	/* check if authentication was successfull */
	if ( stripos($response, "Success") )
	{
		/* send Originate Action */
		fwrite($manager_socket, "Action: Originate\r\n");
		fwrite($manager_socket, "Channel: SIP/33\r\n");
		fwrite($manager_socket, "Context: hello-world\r\n");
		fwrite($manager_socket, "Exten: s\r\n");
		fwrite($manager_socket, "Priority: 1\r\n");
		fwrite($manager_socket, "\r\n");
		$response = fread($manager_socket, 1024);
		print $response;
	}	
	/* Failed Login, print error message */
	else
	{
		print "Failed to login into Asterisk Manager\n";
	}
}
/* unable to open socket, print error string */
else
{
	print "error: {$errstr}\n";
}
?>
